﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.Editors;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGComboBoxOnCellCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel VM = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = VM;            
        }

        int index;
        string s;
        void CVP_PreviewMouseDown(object sender, MouseButtonEventArgs e)
        {
            CellValuePresenter CVP = ((CellValuePresenter)sender);
            DataRecord DR = CVP.Record;
            s = CVP.Field.Label.ToString();
            index = DR.Index;
        }
        //FOR NAME
        private void XamComboEditor_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamComboEditor XCE = ((XamComboEditor)sender);
            if (s == "Name")
            {
                VM.Data[index].Name = XCE.Value.ToString();
            }
        }
        //FOR NUMBER
        private void XamComboEditor_SelectedItemChanged_1(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            XamComboEditor XCE = ((XamComboEditor)sender);
            if (s == "Number")
            {
                VM.Data[index].Number = int.Parse(XCE.Value.ToString());
            }
        }
    }

    public class ViewModel
    {
        public ObservableCollection<Category> Data { get; set; }
        public string[] name = { "C1", "C2", "C3" };
        public int[] number = { 123, 456, 789 };

        public ViewModel()
        {
            Data = new ObservableCollection<Category>();
            for (int i = 0; i < name.Length; i++)
            {
                Data.Add(new Category
                {
                    Name = name[i],
                    Number = number[i]
                });
            }
        }

        public ObservableCollection<string> GetNames()
        {
            ObservableCollection<string> Names = new ObservableCollection<string>();
            for (int i = 0; i < Data.Count; i++)
            {
                Names.Add(Data[i].Name);
            }
            return Names;
        }

        public ObservableCollection<double> GetNumbers()
        {
            ObservableCollection<double> Numbers = new ObservableCollection<double>();
            for (int i = 0; i < Data.Count; i++)
            {
                Numbers.Add(Data[i].Number);
            }

            return Numbers;
        }
    }


    public class Category : INotifyPropertyChanged
    {
        private string name;
        private int number;

        public string Name
        {
            get { return name; }
            set
            {
                if (name != value)
                {
                    name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public int Number
        {
            get { return number; }
            set
            {
                if (number != value)
                {
                    number = value;
                    OnPropertyChanged("Number");
                }
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }
}
